package ex5;

public abstract class Form implements Drawable {
	private char color;
	private boolean filled = false;
	protected Point origin;
	
	public Form(Point origin, char color)
	{
		this.color = color;
		this.origin = origin;
	}
	
	public void setFilled()
	{
		filled = true;
	}
	
	//subclasses must implement this method.
	public abstract boolean isOn(Point p);

	public char getColor() {
		return color;
	}
	
	public boolean isFilled()
	{
		return filled;
	}
	
	public void move(int x, int y)
	{
		origin.move(x,y);
	}
	
	//subclasses must reimplement this method.
	public abstract double area();
	
	//subclasses must reimplement this method.
	public abstract double perimeter();

}
