package ex5;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;

public class Illustration {

	private int length = 60;
	private int height = 40;
	
	ArrayList<Drawable> elements = new ArrayList<Drawable>();

	public void addAsciiNumber(ASCIINumber n)
	{
		elements.add(n);
	}

	public void addForm(Form f)
	{
		elements.add(f);
	}
	public void removeForm(Form form)
	{
		elements.remove(form);
	}
	
	public void draw()
	{
		try {
			clearConsole();
			this.draw(System.out);
		} catch (IOException e) {
			//should never happens on standard out.
			e.printStackTrace(); 
		}
	}
	private void clearConsole() {
		for (int i = 0; i < 60; i++) {
			System.out.println();
		}
	}
	
	
	public void draw(OutputStream out) throws IOException
	{
		for (int i = 0; i < height; i++) {
			for (int j = 0; j < length; j++) {
				char c = ' ';
				for (Drawable form : elements) {
					if(form.isOn(new Point(i,j))) c = form.getColor();
				}
				out.write(c);
			}
			out.write('\n');
		}
	} 
	
	public static void main(String[] args) {
		Illustration picture = new Illustration();
		picture.addForm(new Circle(new Point(10,10),'c',8));
		picture.addForm(new Circle(new Point(10,40),'c',8));
		Circle circle2 = new Circle(new Point(15,20),'o',6);
		circle2.setFilled();
		picture.addForm(circle2);
		Circle circle3 = new Circle(new Point(15,35),'o',6);
		circle3.setFilled();
		picture.addForm(circle3);
		Line line = new Line(new Point(30, 0), '\\', new Point(25,35));
		picture.addForm(line);
		picture.draw();
		
	}
	public Form getForm(char color) {
		for (Drawable form : elements) {
			if(form instanceof Form && 
					form.getColor()==color) 
				return (Form)form;
		}
		return null;
	}
}
